## ros-foxy-maliput 1.1.1

=== CMakeLists.txt ===
##############################################################################
# Project
##############################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(maliput LANGUAGES C CXX VERSION 3.0.0)

##############################################################################
# Find 3rd Party Packages
##############################################################################

message(STATUS "\n\n====== Finding 3rd Party Packages ======\n")

find_package(ament_cmake REQUIRED)
find_package(fmt 6.1.2 EXACT REQUIRED)
find_package(gflags REQUIRED)
find_package(yaml-cpp REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

message(STATUS "\n\n========= Project Configuration ========\n")

set(BUILD_SHARED_LIBS true)

include(${PROJECT_SOURCE_DIR}/cmake/DefaultCFlags.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/SanitizersConfig.cmake)

ament_environment_hooks(
  "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
)

##############################################################################
# Docs
##############################################################################

if(BUILD_DOCS)
  message(STATUS "Doxygen generation - Enabled")
  find_package(ament_cmake_doxygen REQUIRED)
    ament_doxygen_generate(doxygen_maliput
      CONFIG_OVERLAY doc/Doxyfile.overlay.in
      TEST_ON_WARNS
    )
  add_definitions(-DBUILD_DOCS)
else()
  message(STATUS "Doxygen generation - Disabled")
endif()

##############################################################################
# Profiling
##############################################################################

if(MALIPUT_PROFILER_ENABLE)
  message(STATUS "Maliput Profiler - Enabled")
  find_package(ignition-common3 REQUIRED COMPONENTS profiler)
  add_definitions(-DMALIPUT_PROFILER_ENABLE)
  else()
  message(STATUS "Maliput Profiler - Disabled")
endif()

##############################################################################
# Sources
##############################################################################
add_subdirectory(src)

##############################################################################
# Tests
##############################################################################

if(BUILD_TESTING)
  find_package(ament_cmake_clang_format REQUIRED)
  enable_testing()
  add_subdirectory(test)
  ament_clang_format(CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/.clang-format)
endif()

##############################################################################
# Export
##############################################################################

install(
  DIRECTORY include/
  DESTINATION include
)

ament_export_include_directories(include)

ament_environment_hooks(setup.sh.in)
ament_export_dependencies(ament_cmake)
ament_export_dependencies(fmt)
ament_export_dependencies(yaml-cpp)
ament_export_targets(${PROJECT_NAME}-targets HAS_LIBRARY_TARGET)
ament_package()

=== src/CMakeLists.txt ===
add_subdirectory(api)
add_subdirectory(base)
add_subdirectory(common)
add_subdirectory(geometry_base)
add_subdirectory(math)
add_subdirectory(plugin)
add_subdirectory(routing)
add_subdirectory(test_utilities)
add_subdirectory(utility)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(ament_cmake_gmock REQUIRED)
add_subdirectory(api)
add_subdirectory(base)
add_subdirectory(common)
add_subdirectory(geometry_base)
add_subdirectory(math)
add_subdirectory(plugin)
add_subdirectory(test_utilities)
add_subdirectory(utility)

=== src/api/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(API_SOURCES
  basic_id_index.cc
  intersection.cc
  lane.cc
  lane_data.cc
  regions.cc
  road_geometry.cc
  road_network.cc
  road_network_validator.cc
  rules/direction_usage_rule.cc
  rules/discrete_value_rule.cc
  rules/phase.cc
  rules/phase_ring.cc
  rules/range_value_rule.cc
  rules/rule.cc
  rules/rule_registry.cc
  rules/traffic_lights.cc)

add_library(api ${API_SOURCES})

add_library(maliput::api ALIAS api)

set_target_properties(api
  PROPERTIES
    OUTPUT_NAME maliput_api
)

target_include_directories(api
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(api
  PUBLIC
    maliput::common
    maliput::math
)

if(MALIPUT_PROFILER_ENABLE)
  target_link_libraries(api
    PRIVATE
      ignition-common3::profiler
  )
endif()

##############################################################################
# Export
##############################################################################

install(
  TARGETS api
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/base/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(BASE_SOURCES
  intersection.cc
  intersection_book.cc
  intersection_book_loader.cc
  manual_discrete_value_rule_state_provider.cc
  manual_phase_provider.cc
  manual_range_value_rule_state_provider.cc
  manual_right_of_way_rule_state_provider.cc
  manual_phase_ring_book.cc
  manual_rulebook.cc
  phased_discrete_rule_state_provider.cc
  phase_based_right_of_way_rule_state_provider.cc
  phase_ring_book_loader.cc
  phase_ring_book_loader_old_rules.cc
  road_rulebook_loader.cc
  road_rulebook_loader_using_rule_registry.cc
  rule_filter.cc
  rule_registry.cc
  rule_registry_loader.cc
  rule_tools.cc
  traffic_light_book.cc
  traffic_light_book_loader.cc
  yaml_conversion.cc
)

add_library(base ${BASE_SOURCES})

add_library(maliput::base ALIAS base)

set_target_properties(base
  PROPERTIES
    OUTPUT_NAME maliput_base
)

target_include_directories(base
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(base
  PUBLIC
    maliput::api
    maliput::common
    yaml-cpp
)

##############################################################################
# Tests
##############################################################################

##############################################################################
# Export
##############################################################################

include(CMakePackageConfigHelpers)

install(
  TARGETS base
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/common/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(COMMON_SOURCES
  filesystem.cc
  logger.cc
  maliput_abort_and_throw.cc
  range_validator.cc
)

add_library(common ${COMMON_SOURCES})

add_library(maliput::common ALIAS common)

set_target_properties(common
  PROPERTIES
    OUTPUT_NAME maliput_common
)

target_include_directories(common
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(common
  PRIVATE
    fmt::fmt
)

##############################################################################
# Export
##############################################################################

install(
  TARGETS common
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/geometry_base/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################
set(SOURCES
    branch_point.cc
    brute_force_find_road_positions_strategy.cc
    brute_force_strategy.cc
    filter_positions.cc
    junction.cc
    kd_tree_strategy.cc
    lane.cc
    road_geometry.cc
    segment.cc
    strategy_base.cc)

add_library(geometry_base ${SOURCES})

add_library(maliput::geometry_base ALIAS geometry_base)

set_target_properties(geometry_base
  PROPERTIES
    OUTPUT_NAME maliput_geometry_base
)

target_include_directories(geometry_base
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(geometry_base
  PUBLIC
    maliput::api
)

##############################################################################
# Tests
##############################################################################

##############################################################################
# Export
##############################################################################

install(
  TARGETS geometry_base
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/math/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(MATH_SOURCES
  axis_aligned_box.cc
  bounding_box.cc
  matrix.cc
  quaternion.cc
  overlapping_type.cc
  roll_pitch_yaw.cc
  saturate.cc
  vector.cc
)

add_library(math ${MATH_SOURCES})

add_library(maliput::math ALIAS math)

set_target_properties(math
  PROPERTIES
    OUTPUT_NAME maliput_math
)

target_include_directories(math
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(math
  PUBLIC
    maliput::common
)

##############################################################################
# Export
##############################################################################

install(
  TARGETS math
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/plugin/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

add_library(plugin create_road_network.cc maliput_plugin.cc maliput_plugin_manager.cc)
add_library(maliput::plugin ALIAS plugin)

set_target_properties(plugin
  PROPERTIES
    OUTPUT_NAME maliput_plugin
)

target_link_libraries(plugin
  dl
  maliput::api
  maliput::common
  maliput::utility
)

target_include_directories(plugin
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

##############################################################################
# Export
##############################################################################

install(
  TARGETS plugin
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/routing/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(ROUTING_SOURCES
  derive_lane_s_routes.cc
  find_lane_sequences.cc)

add_library(routing ${ROUTING_SOURCES})

add_library(maliput::routing ALIAS routing)

set_target_properties(routing
  PROPERTIES
    OUTPUT_NAME maliput_routing
)

target_include_directories(routing
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(routing
  PUBLIC
    maliput::api
    maliput::common
)

if(MALIPUT_PROFILER_ENABLE)
  target_link_libraries(routing
    PRIVATE
      ignition-common3::profiler
  )
endif()

##############################################################################
# Export
##############################################################################

install(
  TARGETS routing
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/test_utilities/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################
if(BUILD_TESTING)


set(TEST_UTILS_SOURCES
  check_id_indexing.cc
  maliput_math_compare.cc
  maliput_types_compare.cc
  mock.cc
  mock_geometry.cc
  phases_compare.cc
  rules_compare.cc
  rules_direction_usage_compare.cc
  rules_right_of_way_compare.cc
  rules_speed_limit_compare.cc
  traffic_lights_compare.cc)

add_library(test_utilities ${TEST_UTILS_SOURCES})

add_library(maliput::test_utilities ALIAS test_utilities)

set_target_properties(test_utilities
  PROPERTIES
    OUTPUT_NAME maliput_test_utilities
)

target_include_directories(
  test_utilities
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

target_link_libraries(test_utilities
  maliput::api
  maliput::common
  maliput::math
  maliput::geometry_base
)

install(
  TARGETS test_utilities
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

endif()

=== src/utility/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(SOURCES
  file_utils.cc
  generate_obj.cc
  generate_string.cc
  generate_urdf.cc
  mesh_simplification.cc
  segment_analysis.cc
  thread_pool.cc
)
add_library(utility ${SOURCES})

add_library(maliput::utility ALIAS utility)

set_target_properties(utility
  PROPERTIES
    OUTPUT_NAME maliput_utility
)
target_link_libraries(utility
  PRIVATE
    fmt::fmt
  PUBLIC
    stdc++fs
    maliput::api
    maliput::common
    maliput::math
)

if(MALIPUT_PROFILER_ENABLE)
  target_link_libraries(utility
    PRIVATE
      ignition-common3::profiler
  )
endif()

target_include_directories(utility
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

##############################################################################
# Export
##############################################################################

install(
  TARGETS utility
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== debian/changelog ===
ros-foxy-maliput (1.1.1-1focal) focal; urgency=high

  * Provides LaneSRange::GetIntersection method. (#542 <https://github.com/maliput/maliput/issues/542>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Mon, 13 Mar 2023 03:00:00 -0000

ros-foxy-maliput (1.1.0-1focal) focal; urgency=high

  * Adds dimension static const to vector class. (#541 <https://github.com/maliput/maliput/issues/541>)
  * Fixes logger-level-0ff behavior. (#540 <https://github.com/maliput/maliput/issues/540>)
  * Adds maliput profiler (#538 <https://github.com/maliput/maliput/issues/538>)
  * Provides a default ToRoadPosition/FindRoadPosition implementations using kdtree data structure (#517 <https://github.com/maliput/maliput/issues/517>)
  * PhaseRingBookLoader supporting empty rules for the phases. (#536 <https://github.com/maliput/maliput/issues/536>)
  * Provides new-rule-api compatible RoadNetwork's constructor. (#535 <https://github.com/maliput/maliput/issues/535>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Wed, 08 Feb 2023 03:00:00 -0000

ros-foxy-maliput (1.0.9-1focal) focal; urgency=high

  * Provides default populated discrete and range value rule state providers. (#533 <https://github.com/maliput/maliput/issues/533>)
  * Adds a default populated ManualPhaseProvider. (#530 <https://github.com/maliput/maliput/issues/530>)
  * Maliput Plugin: Adds interface for providing default parameters from the backends (#532 <https://github.com/maliput/maliput/issues/532>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Mon, 28 Nov 2022 03:00:00 -0000

ros-foxy-maliput (1.0.8-1focal) focal; urgency=high

  * Brings range validator from maliput_malidrive. (#529 <https://github.com/maliput/maliput/issues/529>)
  * Update triage.yml (#526 <https://github.com/maliput/maliput/issues/526>)
  * Adds convenient test utility method. (#525 <https://github.com/maliput/maliput/issues/525>)
  * Adds a test function for LaneEnds. (#524 <https://github.com/maliput/maliput/issues/524>)
  * Adds IsLanePositionResultClose macro. (#522 <https://github.com/maliput/maliput/issues/522>)
  * Contributors: Agustin Alba Chicar, Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Thu, 10 Nov 2022 03:00:00 -0000

ros-foxy-maliput (1.0.7-1focal) focal; urgency=high

  * Modifies ToLanePosition and adds ToSegmentPosition. (#521 <https://github.com/maliput/maliput/issues/521>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Wed, 14 Sep 2022 03:00:00 -0000

ros-foxy-maliput (1.0.6-1focal) focal; urgency=high

  * Implements KDTree::RangeSearch method. (#520 <https://github.com/maliput/maliput/issues/520>)
  * Adds AxisAlignedBox. (#519 <https://github.com/maliput/maliput/issues/519>)
  * Brings BoundingRegion's related stuff from maliput_object. (#518 <https://github.com/maliput/maliput/issues/518>)
  * Adds KDTree to maliput::math. (#515 <https://github.com/maliput/maliput/issues/515>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Tue, 16 Aug 2022 03:00:00 -0000

ros-foxy-maliput (1.0.5-1focal) focal; urgency=high

  * Provides convenient method for loading a RN via plugins. (#512 <https://github.com/maliput/maliput/issues/512>)
  * Adds triage workflow. (#513 <https://github.com/maliput/maliput/issues/513>)
  * Improves README. (#511 <https://github.com/maliput/maliput/issues/511>)
  * Update README.md with new github.com/maliput URLs (#510 <https://github.com/maliput/maliput/issues/510>)
    Needed due to the transition to the "maliput" organization.
    Also refer developers to new documentation website.
  * Contributors: Chien-Liang Fok, Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Tue, 26 Jul 2022 03:00:00 -0000

ros-foxy-maliput (1.0.4-1focal) focal; urgency=high

  * Fixes include folder installation. (#508 <https://github.com/maliput/maliput/issues/508>)
  * Uses ros-action-ci in build.yaml workflow. (#505 <https://github.com/maliput/maliput/issues/505>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Mon, 13 Jun 2022 03:00:00 -0000

ros-foxy-maliput (1.0.3-1focal) focal; urgency=high

  * moving maliput to the root (#506 <https://github.com/maliput/maliput/issues/506>)
  * Contributors: Tully Foote

 -- Daniel Stonier <daniel.stonier@tri.global>  Wed, 08 Jun 2022 03:00:00 -0000

ros-foxy-maliput (1.0.2-1focal) focal; urgency=high

  * Preparing for binary release

 -- Daniel Stonier <daniel.stonier@tri.global>  Mon, 06 Jun 2022 03:00:00 -0000

ros-foxy-maliput (1.0.1-1focal) focal; urgency=high

  * Preparing for binary release1.0.0 (2021-0X-XX)
  --------------------
  * First official release

 -- Daniel Stonier <daniel.stonier@tri.global>  Thu, 02 Jun 2022 03:00:00 -0000

=== debian/control ===
Source: ros-foxy-maliput
Section: misc
Priority: optional
Maintainer: Daniel Stonier <daniel.stonier@tri.global>
Build-Depends: debhelper (>= 9.0.0), libfmt-dev, libgflags-dev, libyaml-cpp-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format <!nocheck>, ros-foxy-ament-cmake-gmock <!nocheck>, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-maliput
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfmt-dev, libgflags-dev, libyaml-cpp-dev, ros-foxy-ros-workspace
Description: Maliput

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-maliput//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
